#ifndef isolatingBlock_h
#define isolatingBlock_h

#include "capd/capdlib.h"
#include "LocalVField.h"
using namespace capd;

/////////////////////////////
// Function: satisfiesIsolatingBlockCondition()
//
// Purpose: This function can be used to verify that the isolating block condition is satisfied.
// This is needed for establishing unstable manifolds. 
// In this routine we use the bounds on the Jacobian of the vector field on the set 
//     D = B(0,r1) x B(0,r2)
// on which we investigate the isolating block condition.
// The details of the method used for the verification are written out in the 
//    "block_notes.pdf"
// file.
bool satisfiesIsolatingBlockCondition(LocalVField &F, IMatrix DF, int x_dimension, interval r1, interval r2);

#endif