#include "projections.h"

IMatrix Fxx(const IMatrix &DF,const int &k)
{
	IMatrix A(k,k);
	for(int i=0;i<k;i++)
	{
		for(int j=0;j<k;j++) A[i][j]=DF[i][j];
	}
	return A;
}

IMatrix Fxy(const IMatrix &DF,const int &k)
{
	int n=DF.numberOfColumns();
	IMatrix A(k,n-k);
	for(int i=0;i<k;i++)
	{
		for(int j=0;j<n-k;j++) A[i][j]=DF[i][j+k];
	}
	return A;
}

IMatrix Fyx(const IMatrix &DF,const int &k)
{
	int n=DF.numberOfRows();
	IMatrix A(n-k,k);
	for(int i=0;i<n-k;i++)
	{
		for(int j=0;j<k;j++) A[i][j]=DF[i+k][j];
	}
	return A;
}

IMatrix Fyy(const IMatrix &DF,const int &k)
{
	int n=DF.numberOfRows();
	IMatrix A(n-k,n-k);
	for(int i=0;i<n-k;i++)
	{
		for(int j=0;j<n-k;j++) A[i][j]=DF[i+k][j+k];
	}
	return A;
}