#ifndef projections_h
#define projections_h

#include "capd/capdlib.h"
using namespace capd;

////////////////////////
// function: Fxx()
//
// Purpose. This function recovers a fragment of a matrix DF
// We assume that DF is of the form
//
//  (Fxx Fxy)
//  (Fyx Fyy)
//
// and that the dimension of x is k.
IMatrix Fxx(const IMatrix &DF,const int &k);

////////////////////////
// function: Fxy()
//
// Purpose. This function recovers a fragment of a matrix DF
// We assume that DF is of the form
//
//  (Fxx Fxy)
//  (Fyx Fyy)
//
// and that the dimension of x is k.
IMatrix Fxy(const IMatrix &DF,const int &k);

////////////////////////
// function: Fyx()
//
// Purpose. This function recovers a fragment of a matrix DF
// We assume that DF is of the form
//
//  (Fxx Fxy)
//  (Fyx Fyy)
//
// and that the dimension of x is k.
IMatrix Fyx(const IMatrix &DF,const int &k);

////////////////////////
// function: Fyy()
//
// Purpose. This function recovers a fragment of a matrix DF
// We assume that DF is of the form
//
//  (Fxx Fxy)
//  (Fyx Fyy)
//
// and that the dimension of x is k.
IMatrix Fyy(const IMatrix &DF,const int &k);

#endif