#include <iostream>
#include "utils.h"

void abort(string text)
{
	cout << text << endl;
	interval zero=0.0;
	interval error=1.0/zero; // illegal operation to force CAPD to stop computations.
}

void plot(ofstream &file,const interval &x,const interval &y)
{
	file << x.mid().leftBound() << " ";
	file << y.mid().leftBound() << " ";
	file << 0.5*(x.rightBound() - x.leftBound()) << " ";
	file << 0.5*(y.rightBound() - y.leftBound()) << endl;
}

void swapColumns(IMatrix &A,int n,int k)
{
	int j=A.numberOfRows();
	interval a;
	for(int i=0;i<j;i++)
	{
		a=A[i][n];
		A[i][n]=A[i][k];
		A[i][k]=a;
	}
}

interval ScalarProduct(const IVector &x,const IVector &y)
{
	int n=x.dimension();
	interval prod=0.0;
	for(int i=0;i<n;i++) prod=prod+x[i]*y[i];
	return prod;
}