#ifndef utils_h
#define utils_h
#include "capd/capdlib.h"
#include <iostream>
using namespace std;
using namespace capd;

///////////////
// Function: part()
//
// This function disects an interval into 'N' parts and returns the k-th fragment.
inline interval part(const interval &x,const int &N, const int &k){return x.left()+k*(x.right()-x.left())/N+(x-x.left())/N;}

///////////////
// Function: abort()
//
// We use this function to stop our computations. This is computed in particular when some estimates do 
// not go through and the program needs to be terminated. While terminating the program we can write out 
// a text report on what went wrong and which estimates did not go through.
void abort(string text);

////////////////
// Function plot()
//
// This function is used to plot (x,y) into a 'file'.
// The purpose is to allow for a file which can be plotted using gnuplot command:
//    > plot 'filename' w boxxyerrorbars
// thus plotting the boxes (x,y) in gnuplot.
void plot(ofstream &file,const interval &x,const interval &y);

interval ScalarProduct(const IVector &x,const IVector &y);

void swapColumns(IMatrix &A,int n,int k);

#endif
